Uses Cfg;
Uses User;
Uses FBase;
Uses FGroup;

Const
  max_Areas  = 200;
  max_Groups = 50;
  expfile    = 'filelist.txt';
  headerfile = 'header.txt';
  footerfile = 'footer.txt';
  DIZLines   = 100;
  
Type
  RecGroup = Record
    UniqueID : LongInt;
    Name     : String[30];
    gACS      : String[30];
    Hidden   : Boolean;
  End;

Type
  RecFileList = Record
  FileName  : String[70];
  Size      : LongInt;
  DatTim    : LongInt;
  Uploader  : String[30];
  Flags     : Byte;
  Downloads : LongInt;
  Rating    : Byte;
  DescPtr   : LongInt;
  DescLines : Byte;
End;

Type 
  RecBatchEntry = Record
  FileName  : String[40];
  BaseDir   : String[80];
  Tagged    : Boolean;
  Size      : LongInt;
  FBIdx     : Word;
  UserIdx   : Word;
End;

Type 
  RecFileBase = Record
  Index    :Word;
  Name     : String[40];
  FtpName    : String[60];
  FileName   : String[40];
  AnsiFile   : String[20];
  Template   : String[20];
  ListACS    : String[30];
  FtpACS     : String[30];
  DLACS      : String[30];
  ULACS      : String[30];
  CommentACS : String[30];
  SysOpACS   : String[30];
  BaseDir    : String[80];
  DefScan    : Byte;
  Flags      : LongInt;
  Created    : LongInt;
  Res        : Array[1..32] of Byte;
End;
  
Type
  TDataItem = Record
    Text : String[100];
    Idx  : Integer;
  End;

Var
  Batch       : RecBatchEntry;
  Files       : RecFileList;
  AppDir      : String;
  DataPath    : String;
  TempPath    : String;
  FileBase    : RecFileBase;
  Groups      : Array[1..max_Groups] of TDataItem;
  Areas       : Array[1..max_Areas] of TDataItem;
  Total       : Integer = 0;
  TotalAreas  : Integer = 0;
  TotalGroups  : Integer = 0;
  cnt         : Integer;
  ListFile    : file;
  Var DescText    : Array[1..100] of String[55];
  
  DoDownload  : Boolean = False;
  DoHeader    : Boolean = False;
  DoFooter    : Boolean = False;
  DoView      : Boolean = False;
  
Procedure ClearDesc;
Var
  i:byte;
Begin
  For i:=1 to 15 Do DescText[i]:='';
End;

Procedure SortAreas;
Var
	i, j:integer;
   temp1 : TDataItem;
   idx1  : byte;
Begin
	for j:=1 to totalareas do
    For i := 2 to totalareas do begin
      if Areas[i-1].Text>Areas[i].Text then begin
        temp1.text:=Areas[i-1].text;
        temp1.idx:=Areas[i-1].idx;
        Areas[i-1].text:=Areas[i].text;
        Areas[i-1].idx:=Areas[i].idx;
        Areas[i].text:=temp1.text;
        Areas[i].idx:=temp1.idx;
      end;
	end;
End;

Procedure SortGroups;
Var
	i, j:integer;
   temp1 : TDataItem;
   idx1  : byte;
Begin
	for j:=1 to totalgroups do
    For i := 2 to totalgroups do begin
      if Groups[i-1].Text>Groups[i].Text then begin
        temp1.text:=Groups[i-1].text;
        temp1.idx:=Groups[i-1].idx;
        Groups[i-1].text:=Groups[i].text;
        Groups[i-1].idx:=Groups[i].idx;
        Groups[i].text:=temp1.text;
        Groups[i].idx:=temp1.idx;
      end;
	end;
End;
  
Function Size2Str(SZ:LongInt):String;
Var Z : String;
Var Y : Real;
Var S,Ti  : LongInt=1000;
Begin
  If SZ < Ti Then Begin
    Z:=PadLt(Int2Str(SZ),5,' ')+'b';
  End;
  If SZ > Ti Then Begin
    Y:=SZ/1000;
    Z:=PadLt(Real2Str(Y,0),5,' ')+'K';
  End;
    Ti:=Ti*S;
  If SZ > Ti Then Begin
    Y:=SZ/Ti;
    Z:=PadLt(Real2Str(Y,0),5,' ')+'M';
  End;
    Ti:=Ti*S;
  If SZ > Ti Then Begin
    Y:=SZ/Ti;
    Z:=PadLt(Real2Str(Y,0),5,' ')+'G';
  End;
  Size2Str:=Z;
End;

Function ReadFileBase(I:Integer):Boolean;
Var Ret : Boolean=False;
Var Fp  : File;
Begin
  fAssign(Fp,CfgDataPath+'fbases.dat',66);
  fReset(Fp);
  If IoResult = 0 Then Begin
    fSeek(Fp,(I-1)*SizeOf(FileBase));
    If Not fEof(Fp) Then Begin
      fRead(Fp,FileBase,SizeOf(FileBase));
      Ret:=True;
    End;
    fClose(fp);
  End;
  ReadFileBase:=Ret;
End;

Function ReadListEntry(I:Integer):Boolean;
Var Ret : Boolean=False;
Var Fp  : File;
Begin
  fAssign(Fp,DataPath+'.dir',66);
  fReset(Fp);
  If IoResult = 0 Then Begin
    fSeek(Fp,(I-1)*SizeOf(Files));
    If Not fEof(Fp) Then Begin
      fRead(Fp,Files,SizeOf(Files));
      Ret:=True;
    End;
    fClose(Fp);
  End;
  ReadListEntry:=Ret;
End;

Function GetFullDesc(Ofs,Len:LongInt):LongInt;
Var S   : String;
Var Fp    : File;
Var X, Ret  : LongInt;
Var I   : Byte;
Var C   : Char;
Begin

  fAssign(Fp,DataPath+'.des',66);
  fReset(Fp);
  If IoResult = 0 Then Begin
    fSeek(Fp,Ofs);
    I:=1;
    While Not feof(Fp) And I <= Len Do Begin
      X:=fPos(FP);
      fRead(Fp,C,1);
      fSeek(Fp,X);
      fRead(Fp,S,Ord(C)+1);
      DescText[I]:=S;
      I:=I+1;
    End;
    fClose(Fp);
  End;
  GetFullDesc:=Ret;
End;


Function GetFileInfo(F:Integer):Boolean;
Var
  i   : Byte;
  li  : LongInt;
  Ret : Boolean;
Begin
  Ret:=ReadListEntry(F);
  GetFileInfo:=Ret;
  If Not Ret Then Exit;
  ClearDesc;
  li:=GetFullDesc(Files.DescPtr,Files.DescLines);
End;

Procedure GetAreas;
Var
  Temp      : Byte;
  TotFiles  : Integer;
  fp : File;
Begin
  fAssign(Fp,CfgDataPath+'fbases.dat',66);
  fReset(Fp);
  If IoResult = 0 Then Begin
    TotalAreas := 0;
    IgnoreGroups:=true;
    While Not fEOF(fp) Do BEgin
      fRead(Fp,FileBase,SizeOf(FileBase));
      if ACS(Filebase.ListACS) then begin
        TotalAreas        := TotalAreas + 1;
        Areas[TotalAreas].Text := PadRt(FileBase.Name,30,' ');
        Areas[TotalAreas].idx  := FileBase.Index;
      End;
    End;
    fClose(fp);
  End;
End;

Procedure GetGroups;
Var
  Temp  : Byte;
  R     : RecGroup
  fp    : File;
Begin
  fAssign(Fp,CfgDataPath+'groups_f.dat',66);
  fReset(Fp);
  If IoResult = 0 Then Begin
    TotalGroups := 0;
    While Not fEOF(fp) Do BEgin
      fRead(Fp,R,SizeOf(R));
      if ACS(R.gACS) then begin
        TotalGroups        := TotalGroups + 1;
        Groups[TotalGroups].Text := PadRt(r.Name,30,' ');
        Groups[TotalGroups].idx  := r.UniqueID;
      End;
    End;
    fClose(fp);
  End;
End;

Procedure AddtoFile(S:String);
Var
  hp : File;
  Line : String;
Begin
  fAssign(hp,S,66);
  fReset(hp);
  If IoResult <> 0 Then Begin
    WriteLn('Unable to open file.[ '+S+' ]');
    Exit;
  End;
  While Not fEOF(hp) Do Begin
    fReadLn(hp,Line);
    fWriteln(ListFile,Line);
  End;
  fClose(hp);
End;

Procedure BigHeaderToFile(S:String);
Begin
  fWriteln(ListFile,'.'+StrRep('-',77)+'.');
  fWriteln(ListFile,'|'+PadCT(StripB(S,' '),77,' ')+'|');
  fWriteln(ListFile,'`'+StrRep('-',77)+'''');
End;

Procedure BigHeaderToFile2(S:String);
Begin
  fWriteln(ListFile,'+'+StrRep('=',25)+'   '+StrRep('-',20)+'  '+StrRep('-',5));
  fWriteln(ListFile,':'+PadCT(StripB(S,' '),77,' ')+':');
  fWriteln(ListFile,StrRep(' ',23)+StrRep('-',5)+'  '+StrRep('-',20)+'   '+StrRep('=',25)+'+');
End;

Procedure SmallHeaderToFile(S:String);
Begin
  fWriteln(ListFile,'.'+StrRep('-',Length(StripB(S,' '))+2)+'.');
  fWriteln(ListFile,'| '+StripB(S,' ')+' |');
  fWriteln(ListFile,'`'+StrRep('-',Length(StripB(S,' '))+2)+'''');
End;

Procedure List12;
Var
  ig : Integer;
  ia : Integer;
  TSize:Longint;
  p  : Byte = 0;
Begin
  fAssign(ListFile,TempPath + ExpFile,66);
  fReWrite(ListFile);
  If DoHeader Then AddToFile(AppDir+HeaderFile);
    For ia := 1 to TotalAreas Do Begin
      ReadFileBase(Areas[ia].idx);
      
        DataPath:=CfgDatapath+FileBase.FileName;
        BigHeaderToFile2(Areas[ia].Text);
        Total:=1
        Tsize:=0;
        While GetFileInfo(Total) Do Begin
          fWriteln(ListFile,' ');
          fWriteln(ListFile,PadCt('=[ '+Upper(Files.FileName)+' ]=',79,'-'));
          fWriteln(ListFile,PadCt('Size: '+Size2Str(Files.Size)+' // '+DateStr(Files.DatTim,1)+' // Up.: '+Files.Uploader+' // Down. '+Int2Str(Files.Downloads)+' // Rate '+Int2Str(Files.Rating),79,' '));
          fWriteln(ListFile,' ');
          p:=1;
          While DescText[p]<>'' and (p<=DizLines) Do Begin
            If p <= Files.DescLines Then
              fWriteln(ListFile,StrRep(' ',15)+StripMCI(DescText[p]));
            p:=p+1;
          End;
          tsize:=tsize+Files.Size;
          Total:=Total+1;
        End;
        fWriteln(ListFile,' ');
        fWriteln(ListFile,PadRt('Total Files: '+Int2Str(Total-1),50,' ')+PadLT('Total Size: '+Int2Str(TSize)+' b',29,' '));
        fWriteln(ListFile,StrRep(' ',79));
      
  End;
  If DoFooter Then AddToFile(AppDir+FooterFile);
  fClose(ListFile);
End;

Procedure List11;
Var
  ig : Integer;
  ia : Integer;
  TSize:Longint;
  p  : Byte = 0;
Begin
  fAssign(ListFile,TempPath + ExpFile,66);
  fReWrite(ListFile);
  If DoHeader Then AddToFile(AppDir+HeaderFile);
  For ig := 1 To TotalGroups Do Begin
    fWriteln(ListFile,StrRep(' ',79));
    BigHeaderToFile(Groups[ig].Text);
    For ia := 1 to TotalAreas Do Begin
      ReadFileBase(Areas[ia].idx);
      If Pos('z'+Int2Str(Groups[ig].idx),FileBase.ListACS) > 0 Then Begin
        DataPath:=CfgDatapath+FileBase.FileName;
        SmallHeaderToFile(Areas[ia].Text);
        Total:=1
        Tsize:=0;
        While GetFileInfo(Total) Do Begin
          fWriteln(ListFile,PadRt(Size2Str(Files.Size)+ ' / '+Files.FileName,73,' '));
          p:=1;
          While DescText[p]<>'' and (p<=DizLines) Do Begin
            If p <= Files.DescLines Then
              fWriteln(ListFile,StrRep(' ',24)+StripMCI(DescText[p]));
            p:=p+1;
          End;
          tsize:=tsize+Files.Size;
          Total:=Total+1;
        End;
        fWriteln(ListFile,' ');
        fWriteln(ListFile,PadRt('Total Files: '+Int2Str(Total-1),50,' ')+PadLT('Total Size: '+Int2Str(TSize)+' b',29,' '));
        fWriteln(ListFile,StrRep(' ',79));
      End;
    End;
  End;
  If DoFooter Then AddToFile(AppDir+FooterFile);
  fClose(ListFile);
End;

Procedure List3; // DOS Like
Var
  ig : Integer;
  ia : Integer;
  TSize:Longint;
Begin
  fAssign(ListFile,TempPath + ExpFile,66);
  fReWrite(ListFile);
  If DoHeader Then AddToFile(AppDir+HeaderFile);
  For ig := 1 To TotalGroups Do Begin
    fWriteln(ListFile,StrRep(' ',79));
    fWriteln(ListFile,'Directory of /MYSTIC/'+Groups[ig].text);
    For ia := 1 to TotalAreas Do Begin
      ReadFileBase(Areas[ia].idx);
      If Pos('z'+Int2Str(Groups[ig].idx),FileBase.ListACS) > 0 Then Begin
        DataPath:=CfgDatapath+FileBase.FileName;
        fWriteln(ListFile,Upper(PadRT(Areas[ia].text,45,' ')+' <DIR>'+Padlt(DateStr(FileBase.Created,2),9,' ')+' '+TimeStr(FileBase.Created,false)));
        Total:=1
        Tsize:=0;
        While ReadListEntry(Total) Do Begin
          fWriteln(ListFile,PadRt(Files.FileName,45,' ') + Size2Str(Files.Size) + Padlt(DateStr(Files.DatTim,2),9,' ')+' '+TimeStr(Files.DatTim,false));
          tsize:=tsize+Files.Size;
          Total:=Total+1;
        End;
        fWriteln(ListFile,PadRt('     '+Int2Str(Total-1)+' Files',42,' ')+PadLT(Int2Str(TSize)+' Bytes',15,' '));
        fWriteLn(ListFile,'');
      End;
    End;
  End;
  If DoFooter Then AddToFile(AppDir+FooterFile);
  fClose(ListFile);
End;
//-rw-rw-r--  1 x x    2175 ╬£╬¼╬╣  12  2017 anotherdroid.asc
Procedure List4; // Linux Like
Var
  ig : Integer;
  ia : Integer;
  TSize:Longint;
Begin
  fAssign(ListFile,TempPath + ExpFile,66);
  fReWrite(ListFile);
  If DoHeader Then AddToFile(AppDir+HeaderFile);
  For ig := 1 To TotalGroups Do Begin
    fWriteln(ListFile,StrRep(' ',79));
    fWriteln(ListFile,'Directory of /MYSTIC/'+Groups[ig].text);
    For ia := 1 to TotalAreas Do Begin
      ReadFileBase(Areas[ia].idx);
      If Pos('z'+Int2Str(Groups[ig].idx),FileBase.ListACS) > 0 Then Begin
        DataPath:=CfgDatapath+FileBase.FileName;
        fWriteln(ListFile,Upper(PadRT(Areas[ia].text,47,' ')+' <DIR>'));
        Total:=1
        Tsize:=0;
        fWriteln(ListFile,'-r '+PadLT('DN',4,' ')+PadLT('RT',4,' ')+PadLT('UPLOADER',15,' ')+'  SIZE'+Padlt('CREATED',9,' '));
        While ReadListEntry(Total) Do Begin
          fWriteln(ListFile,'-r '+PadLT(Int2Str(Files.Downloads),4,' ')+PadLT(Int2Str(Files.Rating),4,' ')+PadLT(Files.Uploader,15,' ')+Size2Str(Files.Size)+Padlt(DateStr(Files.DatTim,2),9,' ')+' '+TimeStr(Files.DatTim,false)+' '+PadRt(Files.FileName,30,' '));
          tsize:=tsize+Files.Size;
          Total:=Total+1;
        End;
        fWriteln(ListFile,PadRt('     '+Int2Str(Total-1)+' Files',42,' ')+PadLT(Int2Str(TSize)+' Bytes',15,' '));
        fWriteLn(ListFile,'');
      End;
    End;
  End;
  If DoFooter Then AddToFile(AppDir+FooterFile);
  fClose(ListFile);
End;

Procedure List2;
Var
  ig : Integer;
  ia : Integer;
  TSize:Longint;
Begin
  fAssign(ListFile,TempPath + ExpFile,66);
  fReWrite(ListFile);
  If DoHeader Then AddToFile(AppDir+HeaderFile);
  For ig := 1 To TotalGroups Do Begin
    fWriteln(ListFile,StrRep(' ',79));
    BigHeaderToFile(Groups[ig].Text);
    For ia := 1 to TotalAreas Do Begin
      ReadFileBase(Areas[ia].idx);
      If Pos('z'+Int2Str(Groups[ig].idx),FileBase.ListACS) > 0 Then Begin
        DataPath:=CfgDatapath+FileBase.FileName;
        SmallHeaderToFile(Areas[ia].Text);
        Total:=1
        Tsize:=0;
        While ReadListEntry(Total) Do Begin
          fWriteln(ListFile,PadRt('# '+Files.FileName,73,' ') + Size2Str(Files.Size));
          tsize:=tsize+Files.Size;
          Total:=Total+1;
        End;
        fWriteln(ListFile,StrRep('-',79));
        fWriteln(ListFile,PadRt('Total Files: '+Int2Str(Total-1),50,' ')+PadLT('Total Size: '+Int2Str(TSize)+' b',29,' '));
        fWriteln(ListFile,StrRep(' ',79));
      End;
    End;
  End;
  If DoFooter Then AddToFile(AppDir+FooterFile);
  fClose(ListFile);
End;

Procedure List1;
Var
  ig : Integer;
  ia : Integer;
Begin
  fAssign(ListFile,TempPath + ExpFile,66);
  fReWrite(ListFile);
  If DoHeader Then AddToFile(AppDir+HeaderFile);
  For ig := 1 To TotalGroups Do Begin
    fWriteln(ListFile,'|');
    fWriteln(ListFile,'+-[ '+Groups[ig].Text);
    For ia := 1 to TotalAreas Do Begin
      ReadFileBase(Areas[ia].idx);
      Total:=0;
      If Pos('z'+Int2Str(Groups[ig].idx),FileBase.ListACS) > 0 Then Begin
        DataPath:=CfgDatapath+FileBase.FileName;
        fWriteln(ListFile,'|');
        fWriteln(ListFile,'+---[ '+Areas[ia].Text);
        Total:=1
        While ReadListEntry(Total) Do Begin
          fWriteln(ListFile,PadRt('|     '+Files.FileName,73,' ') + Size2Str(Files.Size));
          Total:=Total+1;
        End;
      End;
    End;
  End;
  If DoFooter Then AddToFile(AppDir+FooterFile);
  fClose(ListFile);
End;

Begin
  GetThisUser;
  AppDir := JustPath(ProgName) + 'xq-fblist' + PathChar;
  If Not Acs('s20') Then Begin
    Writeln('As a GUEST you can''t have access to files.');
    TextColor(7);
    ClrScr;
    Exit;
  End;
  //AppDir   := JustPath(ProgName);
  TempPath := AddSlash(CfgTempPath);
  If FileExist(TempPath + expFile) Then FileErase(TempPath + expFile);
  GetGroups;
  SortGroups;
  GetAreas;
  SortAreas;
  TextColor(15);
  
  FileErase(TempPath + ExpFile);
  
  For cnt := 1 To ParamCount Do Begin
    If Upper(ParamStr(cnt)) = '/D' Then DoDownload := True;
    If Upper(ParamStr(cnt)) = '/H' Then DoHeader := True;
    If Upper(ParamStr(cnt)) = '/F' Then DoFooter := True;
    If Upper(ParamStr(cnt)) = '/V' Then DoView := True;

  End;
  
  For cnt := 1 To ParamCount Do Begin
    If Upper(ParamStr(cnt)) = '/1' Then List1;
    If Upper(ParamStr(cnt)) = '/2' Then List2;
    If Upper(ParamStr(cnt)) = '/3' Then List3;
    If Upper(ParamStr(cnt)) = '/4' Then List4;
    If Upper(ParamStr(cnt)) = '/11' Then List11;
    If Upper(ParamStr(cnt)) = '/12' Then List12;
  End;
  //FileCopy(TempPath + ExpFile,CfgSysPath + ExpFile);
  
  If FileExist(TempPath + ExpFile) And DoView Then 
    MenuCMD('GV','ansiviewtxt;ansiviewh;0;'+TempPath + ExpFile);
      
  If FileExist(TempPath + ExpFile) And DoDownload
    Then MenuCMD('F3',TempPath + ExpFile);
    
  
End.
